"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = void 0;
const error_1 = require("./error");
const util_1 = require("./util");
function validate(node) {
    if (util_1.hasConstEnum(node))
        validateConstEnum(node);
    if (node.type === 'and')
        node.and.forEach(subNode => validate(subNode));
    if (node.type === 'or')
        node.or.forEach(subNode => validate(subNode));
}
exports.validate = validate;
function validateConstEnum(node) {
    if (node.enum && node.enum.length === 0)
        throw new error_1.MalformedTypeError("Empty enum is not allowed", node);
    if (node.enum && node.const !== undefined) {
        if (!node.enum.some(entry => util_1.isEqual(entry, node.const)))
            throw new error_1.MalformedTypeError("Enum and const are both set, but enum doesn't contain const", node);
    }
    // TODO: Check data type of enum/const matching type
}
